# Настройка Единой базы блокировок

[Единая база блокировок (ЕББ)](https://cbb.yandex-team.ru) — это внутренний сервис Яндекса, содержащий [идентификаторы пользователей](users.md), запросы которых необходимо блокировать или банить.

Антиробот хранит у себя копию ЕББ и обновляет ее каждые пять минут. При поступлении нового запроса Антиробот проверяет, содержится ли пользователь с данным идентификатором в ЕББ. Если пользователь обнаружен, возвращает ему страницу блокировки или редирект на капчу (см. раздел [Прохождение запроса при использовании Антиробота](scheme.md)).

{% note warning %}

Списки блокируемых пользователей не зависят от сервиса и являются едиными для всего Яндекса. Если вам необходимо внести изменение в эти списки, [напишите команде Антиробота](troubleshooting.md).

{% endnote %}


Списки забаниваемых пользователей настраиваются в ЕББ индивидуально для каждого сервиса.

Чтобы настроить ЕББ:

1. Запросите через [IDM](https://idm.yandex-team.ru) права администратора Единой базы блокировок. Подробнее про авторизацию в ЕББ см. в [Вики](https://wiki.yandex-team.ru/CBB/auth/).
    
1. В [ЕББ](https://cbb.yandex-team.ru) создайте четыре флага для своего сервиса:
    
    - Два флага для бана по регулярному выражению: рабочий и мониторинговый.
    - Два флага для бана по IP-адресу: рабочий и мониторинговый.
    
    Мониторинговый флаг предназначен для тестирования. Он позволяет с помощью [графиков](charts.md#ebb) оценить количество пользователей, которые потенциально могут быть забанены.
    
    Для каждого рабочего и мониторингового флагов укажите:
    
    - Название, по которому можно идентифицировать сервис, к которому относится флаг.
    - Краткое описание флага.
    - Ответственного за флаг (указанный пользователь сможет редактировать параметры флага).
    - Тип флага:
        - 3 — для бана по регулярному выражению;
        - 0 — для бана по IP-адресу.
    
    Условия забанивания пользователей не заполняйте.
    
    После создания каждому флагу будет присвоен идентификационный номер.
    
1. В мониторинговом флаге для бана по регулярному выражению создайте новую запись. Внесите в нее номер мониторингового флага для бана по IP-адресу в формате:
    
    ```
    ip_from=<номер флага>
    ```
    
    Проделайте такую же процедуру с рабочими флагами.
    
1. Укажите номера флагов для бана по регулярному выражению в [конфигурации Антиробота](config.md) (флаги для бана по IP-адресу в конфигурацию не включаются, они работают через флаги для бана по регулярному выражению).
    
    {% include notitle [config-att1](../_includes/warn.md) %}
    

Информацию о настройке флагов для работы Антиробота см. в разделе [Работа с Единой базой блокировок](cbb-work.md).

### Узнайте больше

* [Страница ЕББ в Вики](https://wiki.yandex-team.ru/CBB/)

