# Разметка по типам запросов

Разметка по типам запросов позволяет создать правила, по которым Антиробот может вернуть капчу пользователю в ответ на определенные запросы.

Разметка индивидуальна для каждого сервиса и задается в конфигурации Антиробота.

Чтобы выполнить разметку:

1. Определите ресурсы, при запросе которых пользователю можно возвращать капчу или нельзя, даже если запрос задан роботом.
    
1. Составьте и передайте команде Антиробота список ресурсов в формате:
    
    ```
    "path": "<путь>", _(опц)_"query": "<CGI-параметр>", "req_type": "<тип запроса>"
    ```
    
    Поддерживаемые типы запросов:
    - main — нельзя банить — морда сервиса;
    - favicon — нельзя банить — фавиконки;
    - static — нельзя банить — статика;
    - other — нельзя банить — любые ресурсы, на которые нельзя вернуть капчу;
    - ys — можно банить — любые ресурсы, на которые можно вернуть капчу;
    - api — можно банить — API, на запросы которых сервис умеет возвращать капчу.
    
    Например, `"path": "/yaca/yandsearch", "query": ".*ajax=1.*", req_type": "api"`.
    

Пример размещения разметки по типам запросов в конфигурации Антиробота см. в разделе [Настройка конфигурации](config.md).

