# Идентификация пользователей

Антиробот анализирует каждый поступивший в него запрос и идентифицирует задавшего его пользователя. Определяя роботность, Антиробот учитывает как параметры самого запроса, так и характеристики предыдущих запросов с такой же идентификацией. Если запрос признан роботным, его идентификатор вносится во внутреннюю базу Антиробота (см. раздел [Устройство Антиробота](structure.md)), и все последующие запросы с этой идентификацией будут забанены.

Для идентификации пользователей Антиробот использует куки, а при их отсутствии — IP-адрес.

Куки, которые использует Антиробот для идентификации (в порядке убывания приоритета):

- spravka — собственная кука Антиробота, выставляется при прохождении капчи;
    
- L, L-кука — выставляется при авторизации в Яндекс.Паспорте;
    
- fuid при условии, что она старше одного дня — уникальный идентификатор Flash-куки пользователя (подробнее см. в [ Вики](https://wiki.yandex-team.ru/JandeksPoisk/IzmerenijaStatistika/FleshKuka/));
    
- i, i-кука при условии, что она старше одного дня — кука идентифицирует браузер пользователя (подробнее см. в [Вики](https://wiki.yandex-team.ru/serp/experiments/icookie2/opisanie/#i-cookie));
    
- собственная подписанная кука сервиса — создается сервисом по аналогии с i-кукой. Наличие такой куки обязательно для сервисов, находящихся вне домена Яндекса.

spravka — Уникальная кука, которую Антиробот выставляет пользователю при прохождении капчи. Справка считается отдельным идентификатором, а пользователь с ней — отдельным пользователем. Справка дает пользователю несколько гарантированных запросов, за которые он не будет забанен, даже если Антиробот признает пользователя роботом.    

Идентификация пользователя по IP-адресу применяется в крайнем случае, так как одному IP-адресу может соответствовать множество пользователей.

