# Белые списки

В ряде случаев необходимо, чтобы Антиробот не банил и не блокировал пользователей, даже если их поведение похоже на роботное или точно известно, что это — робот. Например, если запрос пришел из внутренней сети Яндекса. Для работы с такими пользователями созданы Белые списки (White lists). Эти списки не зависят от сервиса и являются едиными для всего Яндекса.

Виды Белых списков:

1. Внутренние сети Яндекса. Список содержит IP-адреса и названия сетей. По запросам пользователей из данного списка Антиробот не возвращает капчу и выставляет специальный флаг внутренней сети.
    
1. <q>Вежливые</q> роботы, которые соблюдают `robots.txt` и имеют механизм reverse-DNS. Список содержит перечень соответствий User-Agent и доменных имен. По запросам пользователей из данного списка Антиробот не возвращает капчу.
    
1. Пользователи, которые имеют статические IP-адреса и не поддерживают механизм reverse-DNS. Список содержит перечень IP-адресов. По запросам пользователей из данного списка Антиробот не возвращает капчу.
    
1. Пользователи, которые не имеют определенного списка IP-адресов и механизма reverse-DNS. Список содержит названия User-Agent. По запросам пользователей из данного списка Антиробот возвращает пустую страницу, то есть не банит, но и не возвращает контент. Актуально для сервисов и приложений, использующих превью.
    

Белые списки хранятся в [Аркадии](https://a.yandex-team.ru/arc/trunk/arcadia/antirobot/scripts/support). Если вам необходимо внести изменение в какой-либо из белых списков, [напишите команде Антиробота](troubleshooting.md).

