# Введение

Этапы подключения:

1. Убедитесь, что ваш сервис удовлетворяет [условиям подключения](prec-conds.md).
    
1. Совместно с командой Антиробота определите идентификатор для вашего сервиса (например, web) и составьте регулярное выражение, по которому Антиробот сможет определять приходящие с сервиса запросы.
    
1. [Обеспечьте прохождение трафика](traffic.md) через Антиробот. Проверьте, что на [графике](charts.md) **Линии про запросы** появилась кривая «Все запросы».
    
1. Задайте в [конфигурации Антиробота](config.md) значение «true» для параметров **enabled** (разрешает работу Антиробота на сервисе) и **blocks_enabled** (включает глобальные флаги блокировок EBB). Проверьте, что на графике **Линии про ЕББ** появились кривые «Заблокированные по IP» и «Заблокированные регулярками».

    Флаги блокировок EBB — списки блокируемых пользователей не зависят от сервиса и являются едиными для всего Яндекса. Если вам необходимо внести изменение в эти списки, [напишите команде Антиробота](troubleshooting.md).
    
    {% include notitle [config-warn](../_includes/warn.md) %}
    
1. [Настройте Единую базу блокировок](cbb.md) для вашего сервиса.
    
1. Напишите [правила разметки запросов](markup.md).
    
1. Задайте в конфигурации Антиробота значение «true» для параметра **bans_enabled**. Проверьте, что на графике **Линии про запросы** появилась кривая «Запросы, которые можно забанить».
    
1. _(для AJAX-запросов)_ Настройте [кастомную верстку капчи или работу с редиректами](ajax-request.md).
    
1. [Проверьте верстку капчи и редиректы](check-layout.md).
    
1. Проверьте корректность срабатывания классификатора по типу запросов. Для этого откройте [лог работы Антиробота](https://yt.yandex-team.ru/hahn/navigation?path=//logs/antirobot-daemon-log2) и убедитесь, что записи в столбцах **req_url** (URL запроса) и **req_type** (<идентификатор сервиса>—<тип запроса>) соответствуют заданной вами разметке (этап 6).
    
    Если появились сомнения в корректности срабатывания Антиробота, [напишите команде](troubleshooting.md). Возможно потребуется обучение новой формулы, специально для вашего сервиса.
    
1. В конфигурации Антиробота снизьте порог до значения, который подходит вашему сервису (параметр **threshold**).
    

После подключения контролируйте работу Антиробота с помощью [графиков](charts.md).

Изменять условия срабатывания Антиробота вы можете с помощью [разметки по типам запросов](markup.md) в конфигурации Антиробота или редактируя [флаги ЕББ](cbb-work.md).
